Package org.eclipse.m2m.atl.engine.vm.nativelib

## Class ASMModelElement

- java.lang.Object
- - org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject
  - - org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny
    - - org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclType
      - - org.eclipse.m2m.atl.engine.vm.nativelib.ASMModelElement

Direct Known Subclasses:
  `ASMEMFModelElement`, `ASMHashModelElement`

    public abstract class ASMModelElement
    extends ASMOclType

An ASMModelElement represents a model element. There is no separate class for special model elements such as metamodel elements. Therefore, some operations of ASMModelElement are only valid for metamodel ASMModelElements.

### Field Summary

### Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclType

`myType`

### Fields inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`nativeImpl`

### Constructor Summary

Constructors
`protected` `ASMModelElement​(ASMModel model, ASMModelElement metaobject)`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract ASMBoolean` `conformsTo​(ASMOclType other)`
`protected static ASMModelElement` `createNewInstance​(StackFrame frame, ASMModelElement self)`
`abstract ASMOclAny` `get​(StackFrame frame, java.lang.String name)`
`ASMModelElement` `getAcquaintance​(java.lang.String name)`
`ASMModelElement` `getMetaobject()`
`ASMModel` `getModel()`
`java.lang.String` `getName()`
`abstract ASMModelElement` `getProperty​(java.lang.String name)`
`abstract ASMModelElement` `getPropertyType​(java.lang.String name)`
`static ASMModelElement` `lookupElementExtended​(StackFrame frame, ASMModelElement self, ASMString name)`
`static ASMModelElement` `otherEnd​(StackFrame frame, ASMModelElement self)`
`void` `set​(StackFrame frame, java.lang.String name, ASMOclAny value)`
`void` `setMetaobject​(ASMModelElement metaobject)`
`protected void` `setName​(java.lang.String name)`
`java.lang.String` `toString()`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclType

`addSupertype, conformsTo, getName, getSupertypes, getVMOperations, registerHelperAttribute, registerVMOperation, registerWeavingHelper`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMOclAny

`asBag, asSequence, asSet, check, debug, findOperation, findOperation, getHelper, getNamedTargetFromSource, getOclAnyType, getType, invoke, invoke, invokeSuper, isHelper, oclIsKindOf, oclIsTypeOf, oclIsUndefined, oclType, operatorEQ, operatorNE, output, refGetValue, refImmediateComposite, refImmediateComposite, refInvokeOperation, refSetValue, refUnsetValue, setType, toString, unset`

### Methods inherited from class org.eclipse.m2m.atl.engine.vm.nativelib.ASMNativeObject

`getNativeImpl`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ASMModelElement

    protected ASMModelElement​(ASMModel model,
                              ASMModelElement metaobject)

### Method Detail

#### get

    public abstract ASMOclAny get​(StackFrame frame,
                                  java.lang.String name)

Description copied from class: `ASMOclType`

Overrides:
  `get` in class `ASMOclType`
See Also:
  `ASMOclAny.get(org.eclipse.m2m.atl.engine.vm.StackFrame, java.lang.String)`

#### set

    public void set​(StackFrame frame,
                    java.lang.String name,
                    ASMOclAny value)

Overrides:
  `set` in class `ASMOclAny`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`

#### setMetaobject

    public void setMetaobject​(ASMModelElement metaobject)

#### getMetaobject

    public ASMModelElement getMetaobject()

#### getModel

    public ASMModel getModel()

#### getName

    public java.lang.String getName()

Specified by:
  `getName` in class `ASMOclType`

#### setName

    protected void setName​(java.lang.String name)

#### conformsTo

    public abstract ASMBoolean conformsTo​(ASMOclType other)

Specified by:
  `conformsTo` in class `ASMOclType`

#### getAcquaintance

    public ASMModelElement getAcquaintance​(java.lang.String name)

#### getProperty

    public abstract ASMModelElement getProperty​(java.lang.String name)

#### getPropertyType

    public abstract ASMModelElement getPropertyType​(java.lang.String name)

#### lookupElementExtended

    public static ASMModelElement lookupElementExtended​(StackFrame frame,
                                                        ASMModelElement self,
                                                        ASMString name)

#### otherEnd

    public static ASMModelElement otherEnd​(StackFrame frame,
                                           ASMModelElement self)

#### createNewInstance

    protected static ASMModelElement createNewInstance​(StackFrame frame,
                                                       ASMModelElement self)

Parameters:
  `frame` -
  `self` - The meta-class to instantiate
Returns:
  A new instance of self, if a suitable target model is found, null otherwise